#include "GameCharFactory.h"
#include "CharLorenzo.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

CharLorenzo::CharLorenzo(GameApp* theApp, GameFrame* theFrame):GameChar(theApp, theFrame)
{
	pApp = theApp;
	pFrame = theFrame;

	pType = -1;
	pName = "";

	mActive = true;
	mSelectable = true;

	pImg = NULL;

	mDirection = 0;
	mWalkNum = 0;

	pIdleImgArray = pApp->mLorenzoIdleImg;
	//pWalkImgArray = (Image***)pApp->mLorenzoWalkImg;

	//Resize(0, 0, 50, 50);
}

CharLorenzo::~CharLorenzo()
{
}

void CharLorenzo::Draw(Graphics* g)
{
	if(!mMoving)
	{
		//pImg = pApp->mLorenzoIdleImg[mDirection];
		pImg = pIdleImgArray[mDirection];
	}
	else
	{
		pImg = pApp->mLorenzoWalkImg[mWalkNum][mDirection];
		//pImg = pWalkImgArray[mWalkNum][mDirection];
	}
	
	//g->SetColor(Color(0,0,255));
	//g->FillRect(0, 0, mWidth, mHeight);
	g->DrawImage(pImg, 0, 0, mWidth, mHeight);

	g->SetColor(mColor);
	g->FillRect(0, 0, mWidth, mHeight);
}

void CharLorenzo::Update()
{
	Widget::Update();

	if(mMoving)
	{
		if(mUpdateCnt%15 == 0)
		{
			mWalkNum++;
			if(mWalkNum > 1)
				mWalkNum = 0;
		}
	}
}
