#include "ObjectChair.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "Customer.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

Customer::Customer(GameApp* theApp, GameFrame* theFrame, eCustomerType theType)
{
	pApp = theApp;
	pFrame = theFrame;
	mType = theType;

	pImg = NULL;

	pDisplayImg = NULL;

	pTable = NULL;

	pIdleImgArray = NULL;

	switch(mType)
	{
	case MALE_NORMAL1:	pIdleImgArray = pApp->mCustomer1SitImg;
						mProbabilityToChoosePizza[0] = 40;
						mProbabilityToChoosePizza[1] = 30;
						mProbabilityToChoosePizza[2] = 20;
						mProbabilityToChoosePizza[3] = 10;
						mProbabilityToChoosePizza[4] = 0;
						break;

	case MALE_NORMAL2:	pIdleImgArray = pApp->mCustomer2SitImg;
						mProbabilityToChoosePizza[0] = 0;
						mProbabilityToChoosePizza[1] = 40;
						mProbabilityToChoosePizza[2] = 30;
						mProbabilityToChoosePizza[3] = 20;
						mProbabilityToChoosePizza[4] = 10;
						break;

	case MALE_NORMAL3:	pIdleImgArray = pApp->mCustomer3SitImg;
						mProbabilityToChoosePizza[0] = 10;
						mProbabilityToChoosePizza[1] = 0;
						mProbabilityToChoosePizza[2] = 40;
						mProbabilityToChoosePizza[3] = 30;
						mProbabilityToChoosePizza[4] = 20;
						break;

	case MALE_NORMAL4:	pIdleImgArray = pApp->mCustomer4SitImg;
						mProbabilityToChoosePizza[0] = 20;
						mProbabilityToChoosePizza[1] = 10;
						mProbabilityToChoosePizza[2] = 0;
						mProbabilityToChoosePizza[3] = 40;
						mProbabilityToChoosePizza[4] = 30;
						break;

	case MALE_NORMAL5:	pIdleImgArray = pApp->mCustomer5SitImg;
						mProbabilityToChoosePizza[0] = 30;
						mProbabilityToChoosePizza[1] = 20;
						mProbabilityToChoosePizza[2] = 10;
						mProbabilityToChoosePizza[3] = 0;
						mProbabilityToChoosePizza[4] = 40;
						break;

	}
}

Customer::~Customer()
{
}

void Customer::Update()
{
	Widget::Update();
}

void Customer::Draw(Graphics* g)
{
	if(pImg == NULL)
	{
		g->SetColor(Color(0, 127, 255));
		g->FillRect(0, 0, mWidth, mHeight);
	}
	else
	{
		g->DrawImage(pImg, 0, 0, mWidth, mHeight);
	}

	if(pDisplayImg != NULL)
	{
		g->SetColor(mDisplayImgColor);
		g->FillRect(10, 10, 30, 30);
		
		g->DrawImage(pDisplayImg, 10, 10, 30, 30);

		g->SetColor(Color(0,0,0));
		g->DrawRect(10, 10, 30, 30);
	}
}

std::string Customer::getTypeInString()
{
	std::string retString = "";

	switch(mType)
	{
	case MALE_NORMAL1: retString = "Normal Customer (Male)"; break;
	}
	
	return retString;
}

void Customer::DisplayImage(Image* theImg, Color theColor)
{
	pDisplayImg = theImg;
	mDisplayImgColor = theColor;
}

void Customer::MouseMove(int x, int y)
{
	pFrame->MouseMove(mParent->mX+x,mParent->mY+y);
}

void Customer::MouseEnter()
{
	if(pTable != NULL)
	{
		pTable->MouseEnter();
	}
}

void Customer::MouseLeave()
{
	if(pTable != NULL)
	{
		pTable->MouseLeave();
	}
}

void Customer::MouseUp(int x, int y, int theBtnNum, int theClickCount)
{
	if(pTable != NULL)
	{
		pTable->MouseUp(x,y,theBtnNum,theClickCount);
	}
}

short Customer::SelectPizza()
{
	short r =  1+Rand()%100;
	short aggregateProbability = 0;

	for(int i=0; i<5; i++)
	{
		aggregateProbability += mProbabilityToChoosePizza[i];
		if(r <= aggregateProbability)
		{
			return i;
		}
	}	

	return 0;
}
