#ifndef __CUSTOMER_H__
#define __CUSTOMER_H__

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;
	class ObjectChair;

class Customer : public Widget
{
	private:
		GameApp* pApp;
		GameFrame* pFrame;
		
		//Stat values: 0-100 only
		short mOrderSpeed;
		short mEatingSpeed;

		short mPatience;
		short mGenerosity;
		short mPickiness;

		// 0-100, total in array must be 100
		short mProbabilityToChoosePizza[5];

		Image* pDisplayImg;
		Color  mDisplayImgColor;

	public:
		Image* pImg;

		Image** pIdleImgArray;

		GameObject* pTable;

		enum eCustomerType {MALE_NORMAL1, MALE_NORMAL2, MALE_NORMAL3, MALE_NORMAL4, MALE_NORMAL5};
		eCustomerType mType;

		enum eStateType {STALLING, WAITING_MENU, DECIDING, WAITING_FOOD, EATING, WAITING_BILL};
		eStateType mState;

	public:
		Customer(GameApp* theApp, GameFrame* theFrame, eCustomerType theType);
		virtual ~Customer();

		virtual void Draw(Graphics* g);
		virtual void Update();

		std::string getTypeInString();

		void DisplayImage(Image* theImg, Color theColor);

		virtual void MouseMove(int x, int y);
		virtual void MouseEnter();
		virtual void MouseLeave();
		virtual void MouseUp(int x, int y, int theBtnNum, int theClickCount);

		short SelectPizza();
};

}

#endif	// __CUSTOMER_H__