#include "FrameFactory.h"
#include "GameApp.h"

#include "FrameMainMenu.h"
#include "FrameInstruction.h"
#include "GameFrame.h"

using namespace Sexy;

FrameFactory::FrameFactory(GameApp* theApp)
{
	pApp = theApp;
}

FrameFactory::~FrameFactory()
{
}

Widget* FrameFactory::getFrame(eFrameName name)
{
	Widget* w = NULL;

	switch(name)
	{
	case MAINMENU:	w = new FrameMainMenu(pApp); break;
	case GAME:		w = new GameFrame(pApp); break;
	case INSTRUCTION:	w = new FrameInstruction(pApp); break;
	}

	/*
	if(name == FrameMainMenu)
	{
		w = new FrameMainMenu(pApp);
	}

	if(name == Game)
	{
		w = new GameFrame(pApp);
	}
	*/

	return w;
}
