#ifndef __FRAMEINSTRUCTION_H__
#define __FRAMEINSTRUCTION_H__

#include "../../../SexyAppFramework/Widget.h"
#include "../../../SexyAppFramework/ButtonListener.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class ButtonWidget;

class FrameInstruction : public Widget, public ButtonListener
{
	private:
		GameApp* pApp;

		enum {BTN_Back, BTN_Next, BTN_Skip, BTN_MainMenu};
		ButtonWidget* mBtnNext;
		ButtonWidget* mBtnBack;
		ButtonWidget* mBtnSkip;
		ButtonWidget* mBtnMainMenu;

		int mPageNum;
		int mPlayingSongNumber;

	public:
		FrameInstruction(GameApp* theApp);
		virtual ~FrameInstruction();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void ButtonDepress(int theId);

};

}

#endif	// __FRAMEINSTRUCTION_H__