#ifndef __MAINMENU_H__
#define __MAINMENU_H__

#include "../../../SexyAppFramework/Widget.h"
#include "../../../SexyAppFramework/ButtonListener.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class ButtonWidget;

class FrameMainMenu : public Widget, public ButtonListener
{
	private:
		GameApp* pApp;

		enum {BTN_NewGame, BTN_QuitGame};
		ButtonWidget* mBtnNewGame;
		ButtonWidget* mBtnQuitGame;

		int mPlayingSongNumber;

	public:
		FrameMainMenu(GameApp* theApp);
		virtual ~FrameMainMenu();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void ButtonDepress(int theId);

};

}

#endif	// __MAINMENU_H__