#ifndef __GAMEAPP_H__
#define __GAMEAPP_H__

#include "FrameFactory.h"

#include "../../../SexyAppFramework/SexyAppBase.h"
#include "../../../SexyAppFramework/Graphics.h"

namespace Sexy
{
	class GameFrame;

	class ImageFont;

class GameApp : public SexyAppBase
{
	private:

	public:
		enum	{ 
				SFX_CashRegister, 
				SFX_Clap,
				SFX_Click,
				SFX_ClockTick,
				SFX_CrowdOoh,
				SFX_Ding, 
				SFX_DoorSlam, 
				SFX_HeartBeat, 
				SFX_HurryUp, 
				SFX_PageTurn,
				SFX_Thud,
				SFX_TrashCan,
				SFX_WhistleHere
				};

		ImageFont* mBigSysFont;
		ImageFont* mSysFont;
		ImageFont* mSmallSysFont;
		
		FrameFactory* mFrameFactory;

		Widget*	pFrame;
		GameFrame* pGameFrame;

		Image* mPizzaDoughImg;

		Image* mBasilImg;
		Image* mGarlicImg;
		Image* mOreganoImg;
		Image* mOnionImg;
		Image* mAnchovyImg;
		Image* mSausageImg;

		Image* mPizzaMargheritaImg;
		Image* mPizzaMarinaraImg;
		Image* mPizzaCipollaImg;
		Image* mPizzaNapoletanaImg;
		Image* mPizzaVienneseImg;

		Image* mOvenImg;
		Image* mTableImg;
		Image* mPrepTableImg;
		Image* mFridgeImg;
		Image* mTrashImg;

		Image* mTileImg;

		Image* mChairImg[4];

		Image* mLorenzoIdleImg[8];
		Image* mLorenzoWalkImg[2][4];

		Image* mCustomer1SitImg[4];
		Image* mCustomer2SitImg[4];
		Image* mCustomer3SitImg[4];
		Image* mCustomer4SitImg[4];
		Image* mCustomer5SitImg[4];

		Image* mBigPizzaLogoImg1;
		Image* mBigPizzaLogoImg2;

		Image* mEuroImg;
		Image* mHeartImg;

		Image* mMainLogoImg;
		Image* mGrayLogoImg;

		Image* mPizzaTimerImg[4];

		Image* mMainMenuBtnDown;
		
		Image* mMuteBtnDown;
		Image* mUnmuteBtnDown;

		Image* mResumeBtnDown;
		Image* mPauseBtnDown;

		Image* mFullscreenBtnDown;
		Image* mWindowedBtnDown;

		Image* mTutorialImg1;
		Image* mTutorialImg2;
		Image* mTutorialImg3;

	public:
		GameApp();
		virtual ~GameApp();	

		virtual void Init();	
		virtual void LoadingThreadProc();	
		virtual void LoadingThreadCompleted();

		virtual void LostFocus();
		virtual void GotFocus();

		void ShowFrame(FrameFactory::eFrameName name);
};

}

#endif	// __GAMEAPP_H__