#include "GameCharFactory.h"
#include "GameChar.h"
#include "GameApp.h"
#include "GameFrame.h"
#include "GameSpace.h"

#include "GameObject.h"

#include "GameNode.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

GameChar::GameChar(GameApp* theApp, GameFrame* theFrame)
{
	pApp = theApp;
	pFrame = theFrame;

	pType = -1;
	pName = "";
	pImg = NULL;

	pDestObj = NULL;

	mActive = true;
	mSelectable = true;
	mSelected = false;

	mHighlightColor = Color(255, 255, 255, 127);
	mNormalColor = Color(0, 0, 0, 0);
	mColor = mNormalColor;

	mMoving = false;
	mMovingStartTime = 0;

	pIdleImgArray = NULL;
	pWalkImgArray = NULL;

	//Resize(0, 480, 800, 120);
}

GameChar::~GameChar()
{
}

void GameChar::Draw(Graphics* g)
{
	g->SetColor(Color(0,0,255));
	g->FillRect(0, 0, mWidth, mHeight);
}

void GameChar::Update()
{
	Widget::Update();
}

void GameChar::AddedToManager(WidgetManager* theWidgetManager)
{
	Widget::AddedToManager(theWidgetManager);

}

void GameChar::RemovedFromManager(WidgetManager* theWidgetManager)
{
	Widget::RemovedFromManager(theWidgetManager);

}

void GameChar::MouseMove(int x, int y)
{
	pFrame->MouseMove(x+mX,y+mY);
}

void GameChar::MouseEnter()
{
	if(mSelectable && !mSelected)
	{
		mColor = mHighlightColor;
		MarkDirty();
	}
}

void GameChar::MouseLeave()
{
	if(mSelectable && !mSelected)
	{
		mColor = mNormalColor;
		MarkDirty();
	}
}

void GameChar::MouseDown(int x, int y, int theBtnNum, int theClickCount)
{
}

void GameChar::MouseUp(int x, int y, int theBtnNum, int theClickCount)
{
	if(mActive && !mSelected)
	{
		mSelected = true;
		//mColor = mHighlightColor;
		mColor = mNormalColor;

		pFrame->pSelectedChar = this;
	}
}

void GameChar::AutoAssign()
{
	int gridsize = pFrame->mGridSize;
	int offsetx = pFrame->mOffsetX;
	int offsety = pFrame->mOffsetY;
	
	if((mX-offsetx)%gridsize == 0)
		mNode.x = (mX-offsetx)/gridsize;
	
	if((mY-offsety)%gridsize == 0)
		mNode.y = (mY-offsety)/gridsize;
}

