#ifndef __GAMECHAR_H__
#define __GAMECHAR_H__

#include "../../../SexyAppFramework/Widget.h"
#include "GameNode.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;

	class GameSimpleNode;

	class GameObject;

class GameChar : public Widget
{
	protected:
		GameApp* pApp;
		GameFrame* pFrame;

	public:
		short pType;
		std::string pName;
		Image* pImg;

		Image** pIdleImgArray;
		Image*** pWalkImgArray;

		bool mActive;
		bool mSelectable;
		bool mSelected;
		Color mColor;
		Color mHighlightColor;
		Color mNormalColor;

		GameObject* pDestObj;

		GameSimpleNode mNode;
		GameSimpleNode mFNode;

		bool mMoving;
		int mMovingStartTime;

		short mDirection;
		short mWalkNum;

		std::vector<GameSimpleNode> mPath;

	public:
		GameChar(GameApp* theApp, GameFrame* theFrame);
		virtual ~GameChar();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void MouseMove(int x, int y);
		virtual void MouseEnter();
		virtual void MouseLeave();
		virtual void MouseDown(int x, int y, int theBtnNum, int theClickCount);
		virtual void MouseUp(int x, int y, int theBtnNum, int theClickCount);

		virtual void AutoAssign();

};

}

#endif	// __GAMECHAR_H__