#include "GameNode.h"
#include "GameApp.h"

using namespace Sexy;

GameSimpleNode::GameSimpleNode(short theX, short theY)
{
	x = theX;
	y = theY;
}

GameSimpleNode::~GameSimpleNode()
{

}

void GameSimpleNode::operator=(GameSimpleNode theNode)
{
	x = theNode.x;
	y = theNode.y;
}

bool GameSimpleNode::operator==(GameSimpleNode theNode)
{
	if (x == theNode.x)
	{
		if (y == theNode.y)
		{
			return true;
		}
	}

	return false;
}



GameNode::GameNode(short theX, short theY) : GameSimpleNode(theX, theY)
{
	pParent = NULL;
	f = 0;
	g = 0;
	h = 0;
}

GameNode::~GameNode()
{

}

void GameNode::operator=(GameNode theNode)
{
	x = theNode.x;
	y = theNode.y;
	f = theNode.f;
	g = theNode.g;
	h = theNode.h;
	pParent = theNode.pParent;
}

GameSimpleNode GameNode::getSimpleNode()
{
	GameSimpleNode r;
	r.x = x;
	r.y = y;

	return r;
}

void GameNode::importSimpleNode(GameSimpleNode theNode)
{
	x = theNode.x;
	y = theNode.y;
}

void GameNode::CopyNode(GameNode* theNode)
{
	x = theNode->x;
	y = theNode->y;
	f = theNode->f;
	g = theNode->g;
	h = theNode->h;
	pParent = theNode->pParent;
}

bool GameNode::EqualTo(GameNode* theNode)
{
	if (x != theNode->x)
	{
		return false;
	}
	else
	{
		if (y != theNode->y)
		{
			return false;
		}
	}

	return true;
}

myPQueue::myPQueue(int capacity, int increment)
{
	mCapacity = capacity;
	mIncrement = increment;

	mQueue = new GameNode*[mCapacity];
	mSize = 0;
}

myPQueue::~myPQueue()
{
	delete mQueue;
}

void myPQueue::remove(GameNode* theNode)
{
	int itr = -1;
	
	for(int i=0; i<mSize; i++)
	{
		if(mQueue[i] == theNode)
		{
			itr = i;
			break;
		}
	}

	if (itr >= 0)
	{
		for(int i=itr; i<mSize-1; i++)
		{
			mQueue[i] = mQueue[i+1];
		}

		mQueue[mSize-1] = NULL;
		mSize--;
	}
}

void myPQueue::sortAsc()
{

}

void myPQueue::sortDec()
{
	if(mSize != 0)
	{
		int min = 100;
		int min_itr = 0;
		
		for(int i=0; i<mSize; i++)
		{
			if(mQueue[i]->f < min)
			{
				min = mQueue[i]->f;
				min_itr = i;
			}
		}

		GameNode* temp = mQueue[min_itr];
		mQueue[min_itr] = mQueue[mSize-1];
		mQueue[mSize-1] = temp;
	}
}

void myPQueue::push(GameNode* theNode)
{
	if (mSize+1 > mCapacity) {
		mCapacity+=mIncrement;
		GameNode** tempQueue = new GameNode*[mCapacity];

		for(int i=0; i<mSize; i++)
		{
			tempQueue[i] = mQueue[i];
		}	

		delete mQueue;

		mQueue = new GameNode*[mCapacity];
			
		for(int i=0; i<mSize; i++)
		{
			mQueue[i] = tempQueue[i];
		}

		delete tempQueue;
	}

	mQueue[mSize] = theNode;
	mSize++;

	if(mSize >= 2)
	{
		for(int i=mSize-2; i>=0; i--)
		{
			if(mQueue[i]->f < mQueue[i+1]->f)
			{
				GameNode* temp = mQueue[i];
				mQueue[i] = mQueue[i+1];
				mQueue[i+1] = temp;
			}
		}
	}
}

GameNode* myPQueue::pop()
{
	GameNode* r = NULL;
		
	if(mSize != 0)
	{
		r = mQueue[mSize-1];

		mQueue[mSize-1] = NULL;
		mSize--;
	}

	return r;
}

int myPQueue::size()
{
	return mSize;
}
