#ifndef __GAMEOBJECT_H__
#define __GAMEOBJECT_H__

#include "../../../SexyAppFramework/Widget.h"
#include "GameNode.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;

	class GameSimpleNode;

	class TObject;
	class Tray;

class GameObject : public Widget
{
	protected:
		GameApp* pApp;
		GameFrame* pFrame;

	public:
		short mType;
		std::string mName;
		Image* pImg;

		bool mActive;
		bool mSelectable;
		bool mUsed;
		Color mColor;
		Color mHighlightColor;
		Color mNormalColor;

		GameSimpleNode mNode;
		GameSimpleNode mFNode;

		bool mConsumer;
		bool mDispenser;

	public:
		GameObject(GameApp* theApp, GameFrame* theFrame);
		virtual ~GameObject();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual TObject* Dispense();
		virtual bool Consume(Tray* theTray);
		virtual void Spawn(int i);
		virtual void Delivered(short id);

		virtual void MouseMove(int x, int y);
		virtual void MouseEnter();
		virtual void MouseLeave();
		virtual void MouseDown(int x, int y, int theBtnNum, int theClickCount);
		virtual void MouseUp(int x, int y, int theBtnNum, int theClickCount);

		virtual void Assign(GameSimpleNode theNode, GameSimpleNode theFNode);

		virtual GameSimpleNode getClosestFNode(GameSimpleNode theNode);
};

}

#endif	// __GAMEOBJECT_H__