#include "GameObjectFactory.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "GameObject.h"
#include "ObjectOven.h"
#include "ObjectPrepTable.h"
#include "ObjectTable.h"
#include "ObjectChair.h"
#include "ObjectFridge.h"
#include "ObjectTrash.h"

using namespace Sexy;

GameObjectFactory::GameObjectFactory(GameApp* theApp, GameFrame* theFrame)
{
	pApp = theApp;
	pFrame = theFrame;
}

GameObjectFactory::~GameObjectFactory()
{
}

GameObject* GameObjectFactory::getObject(short name)
{
	GameObject* go = NULL;

	switch(name)
	{
	case OVEN:		go = new ObjectOven(pApp, pFrame); break;
	case PREPTABLE: go = new ObjectPrepTable(pApp, pFrame); break;
	case TABLE:		go = new ObjectTable(pApp, pFrame); break;
	case CHAIR:		go = new ObjectChair(pApp, pFrame); break;
	case FRIDGE:	go = new ObjectFridge(pApp, pFrame); break;
	case TRASH:		go = new ObjectTrash(pApp, pFrame); break;
	}

	return go;
}
