#ifndef __GAMEOVERLAY_H__
#define __GAMEOVERLAY_H__

#include "../../../SexyAppFramework/Widget.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;

class GameOverlay : public Widget
{
	private:
		GameApp* pApp;
		GameFrame* pFrame;

		int mTimer;
		float mMaxTimer;

	public:
		std::string mDisplayString[5];
		Color		mDisplayStringColor[5];

	public:
		GameOverlay(GameApp* theApp, GameFrame* theFrame, int theTimer);
		virtual ~GameOverlay();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void KeyUp(KeyCode theKey);

};

}

#endif	// __GAMEOVERLAY_H__