#include "GameSpace.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

GameSpace::GameSpace(GameApp* theApp, GameFrame* theFrame)
{
	pApp = theApp;
	pFrame = theFrame;

	pFrame->mColMap[12][0] = 1;
	pFrame->mColMap[13][0] = 1;
	pFrame->mColMap[14][0] = 1;

	pFrame->mColMap[11][0] = 1;
	pFrame->mColMap[11][1] = 1;
	pFrame->mColMap[11][3] = 1;
	pFrame->mColMap[11][4] = 1;
	pFrame->mColMap[11][5] = 1;
	pFrame->mColMap[11][6] = 1;
	pFrame->mColMap[11][8] = 1;
	pFrame->mColMap[11][9] = 1;

	pFrame->mColMap[12][8] = 1;
	pFrame->mColMap[13][8] = 1;
	pFrame->mColMap[14][8] = 1;

	pFrame->mColMap[12][9] = 1;
	pFrame->mColMap[13][9] = 1;
	pFrame->mColMap[14][9] = 1;
	
}

GameSpace::~GameSpace()
{

}

void GameSpace::Draw(Graphics* g)
{
	g->SetColor(Color(171, 171, 171));
	g->FillRect(0, 0, mWidth, mHeight);

	int gridsize = pFrame->mGridSize;
	
	for(int i=0; i<pFrame->mColMapSizeX; i++)
	{
		for(int j=0; j<pFrame->mColMapSizeY; j++)
		{
			g->DrawImage(pApp->mTileImg, i*gridsize, j*gridsize, gridsize, gridsize);
		}
	}

	g->SetColor(Color(0, 0, 0));
	g->FillRect(11*gridsize, 0*gridsize, gridsize*4, gridsize);
	g->FillRect(11*gridsize, 1*gridsize, gridsize, gridsize);

	g->FillRect(11*gridsize, 3*gridsize, gridsize, gridsize*4);

	g->FillRect(11*gridsize, 8*gridsize, gridsize, gridsize);
	g->FillRect(11*gridsize, 9*gridsize, gridsize*4, gridsize);


}

void GameSpace::Update()
{
	Widget::Update();

}

void GameSpace::AddedToManager(WidgetManager* theWidgetManager)
{
	Widget::AddedToManager(theWidgetManager);
}

void GameSpace::RemovedFromManager(WidgetManager* theWidgetManager)
{
	Widget::RemovedFromManager(theWidgetManager);
}

void GameSpace::MouseMove(int x, int y)
{
	pFrame->MouseMove(x+mX,y+mY);
}

void GameSpace::MouseUp(int x, int y, int theBtnNum, int theClickCount)
{
	pFrame->MouseUp(x,y,theBtnNum,theClickCount);
}
