#ifndef __GAMEUI_H__
#define __GAMEUI_H__

#include "../../../SexyAppFramework/Widget.h"
#include "../../../SexyAppFramework/ButtonListener.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;
	class ButtonWidget;
	class HappinessBar;
	class PizzaTimer;

class GameUI : public Widget, public ButtonListener
{
	private:
		GameApp* pApp;
		GameFrame* pFrame;

		enum {BTN_MainMenu, BTN_PauseGame, BTN_ToggleFullScreen, BTN_Mute};
		ButtonWidget* mBtnMainMenu;
		ButtonWidget* mBtnPauseGame;
		ButtonWidget* mBtnToggleFullScreen;
		ButtonWidget* mBtnMute;

		HappinessBar* mHappinessBar;

	public:
		PizzaTimer* mPizzaTimer;

	public:
		GameUI(GameApp* theApp, GameFrame* theFrame);
		virtual ~GameUI();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void MouseMove(int x, int y);

		virtual void ButtonDepress(int theId);

		virtual void TogglePauseGame(bool forcePaused=false);

};

}

#endif	// __GAMEUI_H__