#include "GameApp.h"
#include "GameFrame.h"
#include "HappinessBar.h"

#include "../../../SexyAppFramework/WidgetManager.h"
#include "../../../SexyAppFramework/ImageFont.h"

using namespace Sexy;

HappinessBar::HappinessBar(GameApp* theApp, GameFrame* theFrame)
{
	pApp = theApp;
	pFrame = theFrame;

	Resize(0,0, 390, 40);

	mWarned = false;
}

HappinessBar::~HappinessBar()
{

}

void HappinessBar::Draw(Graphics* g)
{

	g->mColorizeImages = true;
	g->SetColor(Color(255,190,190));
	g->DrawImage(pApp->mHeartImg, 0, 0);
	g->mColorizeImages = false;

	g->SetColor(Color(127,127,127));
	//g->FillRect(0,0,40,40);
	g->FillRect(45,4,335,22);

	g->SetColor(Color(0,0,0));
	g->DrawRect(45,4,334,21);

	int goalLine = 46+333.0f*pFrame->mGoalLine/pFrame->mMaxReputation;
	int dangerLine = 46+333.0f*pFrame->mDangerLine/pFrame->mMaxReputation;
	int repWidth = 333.0f*pFrame->mReputation/pFrame->mMaxReputation;

	if (repWidth>333) repWidth = 333;
	if (repWidth<0) repWidth = 0;

	if(pFrame->mReputation >= pFrame->mGoalLine)
		g->SetColor(Color(0,255,0));
	else if(pFrame->mReputation < pFrame->mDangerLine)
		g->SetColor(Color(255,0,0));
	else
		g->SetColor(Color(63,223,63));

	g->FillRect(46,5,repWidth,20);

	g->SetColor(Color(0,255,0));
	
	g->DrawLine(goalLine, 0, goalLine, 30);
	g->DrawLine(goalLine-1, 0, goalLine-1, 30);
	//g->FillRect(goalLine-5, 30, 10, 10);
	g->SetFont(pApp->mSmallSysFont);
	g->WriteString("GOAL", goalLine+3 , 35, 0, -1);

	g->SetColor(Color(255,0,0));
	g->DrawLine(dangerLine, 0, dangerLine, 30);
	g->DrawLine(dangerLine-1, 0, dangerLine-1, 30);
	//g->FillRect(dangerLine-5, 30, 10, 10);
	g->SetFont(pApp->mSmallSysFont);
	g->WriteString("DANGER", dangerLine-3 , 35, 0, 1);

	if(pFrame->mReputation >= pFrame->mGoalLine)
	{
		g->SetColor(Color(0,255,0,127));
		g->FillRect(44,3,repWidth+4,24);
	}
	
	if(pFrame->mReputation < pFrame->mDangerLine)
	{
		g->SetColor(Color(255,0,0,127));
		g->FillRect(44,3,repWidth+4,24);
	}
}

void HappinessBar::Update()
{
	Widget::Update();

	if(!pFrame->mPaused && !pFrame->mGamePaused)
	{
		if(mUpdateCnt%100 == 0)
		{
			if(pFrame->mReputation < pFrame->mDangerLine)
			{
				if(mWarned == false)
				{
					pApp->PlaySample(GameApp::SFX_HeartBeat);
					mWarned = true;
				}
			}
			else
			{
				mWarned = false;
			}
		}
	}
}

void HappinessBar::MouseMove(int x, int y)
{
	//pFrame->MouseMove(mX+x, mY+y);
}
