#include "GameObjectFactory.h"
#include "GameObject.h"
#include "ObjectChair.h"

#include "GameApp.h"
#include "GameFrame.h"

#include "TObject.h"
#include "TObjectFactory.h"

#include "Customer.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

ObjectChair::ObjectChair(GameApp* theApp, GameFrame* theFrame):GameObject(theApp, theFrame)
{
	mType = GameObjectFactory::CHAIR;
	mName = "Chair";
	pImg = NULL;

	//Resize(0, 0, 50, 50);

	mSelectable = false;

	pCustomer = NULL;
}

ObjectChair::~ObjectChair()
{
}

void ObjectChair::Draw(Graphics* g)
{
	int inset = 4;
	
	int startX = inset;
	int startY = inset;
	
	if(mFNode.x > mNode.x)
	{
		startX += inset;
	}
	else if(mFNode.x < mNode.x)
	{
		startX = 0;
	}

	if(mFNode.y > mNode.y)
	{
		startY += inset;
	}
	else if(mFNode.y < mNode.y)
	{
		startY = 0;
	}
	
	if(pImg == NULL)
	{
		g->SetColor(Color(0, 127, 255));
		g->FillRect(startX, startY, mWidth-inset*2, mHeight-inset*2);
	}
	else
	{
		g->DrawImage(pImg, 0, 0, mWidth, mHeight);
	}
	
	g->SetColor(mColor);
	g->FillRect(startX, startY, mWidth-inset*2, mHeight-inset*2);
}

void ObjectChair::Update()
{
	Widget::Update();
}

void ObjectChair::AddedToManager(WidgetManager* theWidgetManager)
{
	Widget::AddedToManager(theWidgetManager);
}

void ObjectChair::RemovedFromManager(WidgetManager* theWidgetManager)
{
	RemoveAllWidgets();
	
	Widget::RemovedFromManager(theWidgetManager);
}

void ObjectChair::DisplayImage(Image* theImg, Color theColor)
{
	if(pCustomer != NULL)
	{
		pCustomer->DisplayImage(theImg, theColor);
	}
}
