#ifndef __OBJECTCHAIR_H__
#define __OBJECTCHAIR_H__

#include "GameObject.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;

	class TObject;
	class TObjectFactory;

	class ObjectChair;

	class Customer;
	class Image;
	class Color;

	class Tray;

class ObjectChair : public GameObject
{
	private:
		enum eStateType {EMPTY, WAITING_MENU, DECIDING, WAITING_FOOD, EATING, WAITING_BILL};
		eStateType mState;

	public:
		Customer* pCustomer;
		short mDirection;

	public:
		ObjectChair(GameApp* theApp, GameFrame* theFrame);
		virtual ~ObjectChair();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		void DisplayImage(Image* theImg, Color theColor);

};

}

#endif	// __OBJECTCHAIR_H__