#ifndef __OBJECTFRIDGE_H__
#define __OBJECTFRIDGE_H__

#include "GameObject.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;
	class TObject;
	class TObjectFactory;

	class Selector;

	class Tray;

class ObjectFridge : public GameObject
{
	private:
		Selector* mIngredientSelector;
		short mSelectedIngredient;

	public:
		ObjectFridge(GameApp* theApp, GameFrame* theFrame);
		virtual ~ObjectFridge();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual TObject* Dispense();
		virtual bool Consume(Tray* theTray);

		virtual void Delivered(short id);

		virtual void Assign(GameSimpleNode theNode, GameSimpleNode theFNode);

		virtual GameSimpleNode getClosestFNode(GameSimpleNode theNode);

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void MouseEnter();
		virtual void MouseLeave();

};

}

#endif	// __OBJECTFRIDGE_H__