#ifndef __OBJECTORDERTABLE_H__
#define __OBJECTORDERTABLE_H__

#include "GameObject.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;
	class TObject;
	class TObjectFactory;

class ObjectOrderTable : public GameObject
{
	private:
		TObject* mOrder;
		GameObject* pTable;

		int mPizzaContainerSize;
		TObject** mPizzaContainer;

		int mPizzaArraySize;
		bool* mPizzaFillArray;
		bool* mPizzaDeliveryArray;

		int mNumPizzaDelivered;
		int mNumPizzaFilled;

		enum eStateType {EMPTY, WAITING_FILL, WAITING_PICKUP};
		eStateType mState;

	public:
		ObjectOrderTable(GameApp* theApp, GameFrame* theFrame);
		virtual ~ObjectOrderTable();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual TObject* Dispense();
		virtual bool Consume(TObject* object);
		virtual void Delivered(short id);

		void resizePizzaContainer(int newSize);
		void addPizza(TObject* thePizza);
		bool removePizza(short theId);

		void DeliverPizza(short id);

		void initArrays();
		void releaseArrays();

		void setState(eStateType newStatus);

};

}

#endif	// __OBJECTORDERTABLE_H__