#ifndef __OBJECTPREPTABLE_H__
#define __OBJECTPREPTABLE_H__

#include "GameObject.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;
	class TObject;
	class TObjectFactory;

	class Selector;

	class Tray;

class ObjectPrepTable : public GameObject
{
	private:
		int mIngredientContainerSize;
		short* mIngredientSpecs;
		bool* mIngredientContainer;
		int mNumIngredientContained;

		TObject* mPizza;

		enum eStateType {EMPTY, WAITING_FILL, WAITING_PICKUP};
		eStateType mState;

		Selector* mPizzaSelector;
		short mSelectedPizza;

		bool mShowPizza;

	public:
		ObjectPrepTable(GameApp* theApp, GameFrame* theFrame);
		virtual ~ObjectPrepTable();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual TObject* Dispense();
		virtual bool Consume(Tray* theTray);

		virtual void Delivered(short id);

		virtual void MouseEnter();
		virtual void MouseLeave();

		void setState(eStateType newStatus);
		void setPizza(short id, bool flag);
};

}

#endif	// __OBJECTPREPTABLE_H__