#ifndef __OBJECTTABLE_H__
#define __OBJECTTABLE_H__

#include "GameObject.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;
	class TObject;
	class TObjectFactory;

	class ObjectChair;
	class Customer;

	class Tray;

class ObjectTable : public GameObject
{
	private:
		bool* mPlateArray;
		bool* mMenuArray;
		bool* mDirtyArray;

		int mTimer;
		int mCountdown;

		short mChairArraySize;
		ObjectChair** mChairArray;

		int mTotalWaitTime;

		int mPizzaDelivered;

		//Image** pPizzaImgArray;
		//short* mPizzaDeliveredArray;

		TObject** mPizzaArray;

	public:
		enum eStateType {EMPTY, WAITING_MENU, DECIDING, WAITING_ORDER, WAITING_FOOD, EATING, WAITING_BILL, DIRTY};
		eStateType mState;	
		TObject* mOrder;

		short mNumChairs;
		short mNumCustomers;

	public:
		ObjectTable(GameApp* theApp, GameFrame* theFrame);
		virtual ~ObjectTable();	

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual TObject* Dispense();
		virtual bool Consume(Tray* theTray);
		virtual void Spawn(int i);
		virtual void Delivered(short id);

		virtual GameSimpleNode getClosestFNode(GameSimpleNode theNode);

		void setChair(int i, bool theFlag);

		void setState(eStateType newStatus);

		void generateOrder();

		void addCustomer(Customer* newCustomer);
		void removeCustomers();

};

}

#endif	// __OBJECTTABLE_H__