#include "GameApp.h"
#include "GameFrame.h"
#include "GameObject.h"
#include "GameObjectFactory.h"

#include "Tray.h"
#include "TObject.h"

#include "ObjectTrash.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

ObjectTrash::ObjectTrash(GameApp* theApp, GameFrame* theFrame):GameObject(theApp, theFrame)
{
	pImg = pApp->mTrashImg;

	mType = GameObjectFactory::TRASH;
	mName = "Trash Can";

	mSelectable = true;

	mConsumer = true;
	mDispenser = false;
}

ObjectTrash::~ObjectTrash()
{
}

void ObjectTrash::Update()
{
	Widget::Update();
}

void ObjectTrash::Draw(Graphics* g)
{
	if(pImg != NULL)
	{
		g->DrawImage(pImg, 0, 0, mWidth, mHeight);
	}
	else
	{
		g->SetColor(Color(0, 127, 255));
		g->FillRect(0, 0, mWidth, mHeight);
	}

	g->SetColor(mColor);
	g->FillRect(0, 0, mWidth, mHeight);
}

bool ObjectTrash::Consume(Tray* theTray)
{
	if(theTray!= NULL && !theTray->isEmpty())
	{
		TObject* topitem = theTray->getTopItem();
		if(topitem->pSourceObject != NULL)
		{
			//topitem->pSourceObject->Delivered(mType);
		}

		theTray->removeItem(topitem);
		delete topitem;

		pApp->PlaySample(GameApp::SFX_TrashCan);

		return true;
	}
	else
	{
		pApp->PlaySample(GameApp::SFX_Thud);
	}
	
	return false;
}
