#include "GameApp.h"
#include "GameFrame.h"
#include "PizzaTimer.h"

#include "../../../SexyAppFramework/WidgetManager.h"
#include "../../../SexyAppFramework/SysFont.h"
#include "../../../SexyAppFramework/ImageFont.h"

using namespace Sexy;

PizzaTimer::PizzaTimer(GameApp* theApp, GameFrame* theFrame)
{
	pApp = theApp;
	pFrame = theFrame;

	Resize(0,0, 200, 100);

	mWarned = false;
}

PizzaTimer::~PizzaTimer()
{

}

void PizzaTimer::Draw(Graphics* g)
{


	g->SetColor(Color(127,127,127));

	if(pFrame->mTimer > pFrame->mDayDuration/4)
		g->mColorizeImages = true;

	g->DrawImage(pApp->mPizzaTimerImg[0], mWidth/2, 0);
	g->mColorizeImages = false;

	if(pFrame->mTimer > 2*pFrame->mDayDuration/4)
		g->mColorizeImages = true;

	g->DrawImage(pApp->mPizzaTimerImg[1], mWidth/2, mHeight/2);
	g->mColorizeImages = false;
		
	if(pFrame->mTimer > 3*pFrame->mDayDuration/4)
		g->mColorizeImages = true;

	g->DrawImage(pApp->mPizzaTimerImg[2], 0, mHeight/2);
	g->mColorizeImages = false;
	
	if(pFrame->mTimer > 4*pFrame->mDayDuration/4)
		g->mColorizeImages = true;

	g->DrawImage(pApp->mPizzaTimerImg[3], 0, 0);
	g->mColorizeImages = false;

	if(pFrame->mTimer > 3*pFrame->mDayDuration/4)
		g->SetColor(Color(255,0,0));
	else
		g->SetColor(Color(0,0,0));
	g->SetFont(pApp->mBigSysFont);
	
	int sec = (pFrame->mDayDuration - pFrame->mTimer)/100;
	int minute = sec/60;
	sec = sec%60;

	std::string minuteString = StrFormat("%d", minute);
	std::string secString = StrFormat("%d", sec);
/*
	if (minute < 10)
		minuteString = "0" + minuteString;
*/
	if (sec < 10)
		secString = "0" + secString;

	g->WriteString(minuteString + ":" + secString, 50, 40+pApp->mSysFont->GetHeight()-3, 100, 0);

}

void PizzaTimer::Update()
{
	Widget::Update();

	if(!pFrame->mPaused && !pFrame->mGamePaused)
	{
		if(mUpdateCnt%100 == 0)
		{
			pFrame->MarkDirty();

			if(pFrame->mTimer >= 3*pFrame->mDayDuration/4)
			{
				if (mWarned == false)
				{
					pApp->PlaySample(GameApp::SFX_ClockTick);
					mWarned = true;
				}
			}
			else
			{
				mWarned == false;
			}
		}
	}
}

void PizzaTimer::MouseMove(int x, int y)
{
	pFrame->MouseMove(mX+x, mY+y);
}
