#include "GameApp.h"
#include "GameFrame.h"
#include "PopupMsg.h"

#include "../../../SexyAppFramework/WidgetManager.h"
#include "../../../SexyAppFramework/ImageFont.h"

using namespace Sexy;

PopupMsg::PopupMsg(GameApp* theApp, GameFrame* theFrame, int theTimer)
{
	pApp = theApp;
	pFrame = theFrame;
	mTimer = theTimer;
	mMaxTimer = theTimer;

	Resize(0,0, 100, 40);

	pDisplayImage1 = NULL;
	mImageColor1 = Color(255,255,255,255);
	pDisplayImage2 = NULL;
	mImageColor2 = Color(255,255,255,255);
}

PopupMsg::~PopupMsg()
{

}

void PopupMsg::Draw(Graphics* g)
{

	//g->SetColor(Color(127,127,127));
	//g->FillRect(0,0,mWidth,mHeight);

	int tempAlpha = mTimer/mMaxTimer * 510;
	if (tempAlpha > 255) tempAlpha = 255;

	Color c;

	if(pDisplayImage1 != NULL)
	{
		if(mImageColor1.mAlpha != 0)
		{
			g->mColorizeImages = true;
			mImageColor1.mAlpha = tempAlpha;
			g->SetColor(mImageColor1);
		}
		else
			g->mColorizeImages = false;
		
		g->DrawImage(pDisplayImage1, mWidth/2-22-pApp->mSysFont->StringWidth(mDisplayString1)/2, mHeight-25, 25, 25);
		g->mColorizeImages = false;
	}

	c.mRed = mStringColor1.mRed;
	c.mGreen = mStringColor1.mGreen;
	c.mBlue = mStringColor1.mBlue;
	c.mAlpha = tempAlpha;

	g->SetColor(c);
	g->SetFont(pApp->mSysFont);
	g->WriteString(mDisplayString1, 0 , mHeight-5, mWidth, 0);


	if(pDisplayImage2 != NULL)
	{
		if(mImageColor2.mAlpha != 0)
		{
			g->mColorizeImages = true;
			mImageColor2.mAlpha = tempAlpha;
			g->SetColor(mImageColor2);
		}
		else
			g->mColorizeImages = false;
		
		g->DrawImage(pDisplayImage2, mWidth/2-22-pApp->mSysFont->StringWidth(mDisplayString2)/2, mHeight-45, 25, 25);
		g->mColorizeImages = false;
	}

	c.mRed = mStringColor2.mRed;
	c.mGreen = mStringColor2.mGreen;
	c.mBlue = mStringColor2.mBlue;
	c.mAlpha = tempAlpha;


	g->SetColor(c);
	g->SetFont(pApp->mSysFont);
	g->WriteString(mDisplayString2, 0 , mHeight-25, mWidth, 0);


}

void PopupMsg::Update()
{
	Widget::Update();

	if(!pFrame->mGamePaused && !pFrame->mPaused)
	{
		if(mTimer > 0)
		{
			mTimer--;
			if((int)(mMaxTimer - mTimer)%(int)(mMaxTimer/10) == 0)
				Move(mX, mY-1);
		}
		else if(mTimer == 0)
		{
			mWidgetManager->RemoveWidget(this);
			pFrame->MarkDirty();
		}
	}
}

void PopupMsg::MouseMove(int x, int y)
{
	pFrame->MouseMove(mX+x, mY+y);
}

void PopupMsg::AddedToManager(WidgetManager* theWidgetManager)
{
	Widget::AddedToManager(theWidgetManager);
}

void PopupMsg::RemovedFromManager(WidgetManager* theWidgetManager)
{
	pApp->SafeDeleteWidget(this);

	Widget::RemovedFromManager(theWidgetManager);
}

void PopupMsg::Center(int theX, int theY)
{
	Move(theX-mWidth/2, theY-mHeight);
}

