#ifndef __SELECTOR_H__
#define __SELECTOR_H__

#include "../../../SexyAppFramework/Widget.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameObject;
	class GameFrame;

	class TObject;
	class SelectorItem;

class Selector : public Widget
{
	protected:
		GameApp* pApp;
		GameFrame* pFrame;

	public:
		std::string mDisplayText;
		Image* pImg;

		Color mColor;
		Color mHighlightColor;
		Color mNormalColor;

		bool mSelectable;
		bool mDraw;

		GameObject* pSourceObject;

		int mItemArraySize;
		SelectorItem** mItemArray;

	public:
		Selector(GameApp* theApp, GameFrame* theFrame, GameObject* theSrcObj);
		virtual ~Selector();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void MouseMove(int x, int y);
		virtual void MouseEnter();
		virtual void MouseLeave();
		virtual void MouseDown(int x, int y, int theBtnNum, int theClickCount);
		virtual void MouseUp(int x, int y, int theBtnNum, int theClickCount);

		virtual void AddItem(short theId, Image* theImg, std::string theText, Color theColor);
		virtual void RemoveItem(short theId);

		virtual void Reposition();

		virtual void ShowSelector(bool flag);
};

}

#endif	// __SELECTOR_H__