#ifndef __SELECTORITEM_H__
#define __SELECTORITEM_H__

#include "../../../SexyAppFramework/Widget.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameObject;
	class GameFrame;

	class TObject;
	class Selector;

class SelectorItem : public Widget
{
	protected:
		GameApp* pApp;
		GameFrame* pFrame;
		Selector* pSelector;

	public:
		std::string mText;
		Image* pImg;
		short mId;

		Color mBgColor;

		Color mColor;
		Color mHighlightColor;
		Color mNormalColor;

		bool mSelectable;
		bool mDraw;

	public:
		SelectorItem(GameApp* theApp, GameFrame* theFrame, Selector* theSelector, Color theBgColor=Color(255,255,255,127));
		virtual ~SelectorItem();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void MouseMove(int x, int y);
		virtual void MouseEnter();
		virtual void MouseLeave();
		virtual void MouseDown(int x, int y, int theBtnNum, int theClickCount);
		virtual void MouseUp(int x, int y, int theBtnNum, int theClickCount);
};

}

#endif	// __SELECTORITEM_H__