#include "TObjectFactory.h"
#include "TObject.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

TObject::TObject(GameApp* theApp,  GameFrame* theFrame)
{
	pApp = theApp;
	pFrame = theFrame;

	mType = -1;
	mName = "";
	pImg = NULL;

	mIngredient = false;
	mCookedFood = false;

	mArraySize = 0;
	mArray = NULL;

	mTimer = -1;

	pSourceObject = NULL;

	Resize(0, 0, 25, 25);

	mColor = Color(255,255,255);

	mDelivered = false;
}

TObject::~TObject()
{
	delete[] mArray;
}

void TObject::Draw(Graphics* g)
{
	g->SetColor(mColor);
	g->FillRect(0, 0, mWidth, mHeight);
}

void TObject::Update()
{
	Widget::Update();

	if(mTimer >= 0)
	{
		mTimer++;
	}
}

void TObject::AddedToManager(WidgetManager* theWidgetManager)
{
	Widget::AddedToManager(theWidgetManager);

}

void TObject::RemovedFromManager(WidgetManager* theWidgetManager)
{
	Widget::RemovedFromManager(theWidgetManager);

}

void TObject::MouseMove(int x, int y)
{
	pFrame->MouseMove(x+mX,y+mY);
}

void TObject::InitArray(int num)
{
	if(mArraySize != 0 && mArray != NULL)
	{
		delete mArray;
		mArraySize = 0;
	}

	mArraySize = num;
	mArray = new short[mArraySize];
}

TObject* TObject::Copy()
{
	TObject* newObj = new TObject(pApp, pFrame);

	newObj->mType = mType;
	newObj->mName = mName;
	newObj->pImg = pImg;
	newObj->mColor = mColor;

	newObj->mIngredient = mIngredient;
	newObj->mCookedFood = mCookedFood;

	newObj->InitArray(mArraySize);
	for(int i=0; i<newObj->mArraySize; i++)
	{
		newObj->mArray[i] = mArray[i];
	}

	newObj->mTimer = mTimer;

	newObj->pSourceObject = pSourceObject;

	return newObj;
}

Image* TObject::getImage()
{
	return pImg;
}