#ifndef __TOBJECT_H__
#define __TOBJECT_H__

#include "../../../SexyAppFramework/Widget.h"

namespace Sexy
{
	class Graphics;
	class WidgetManager;

	class GameApp;
	class GameFrame;
	class GameObject;

class TObject : public Widget
{
	protected:
		GameApp* pApp;
		GameFrame* pFrame;

	public:
		short mType;
		std::string mName;
		Image* pImg;

		Color mColor;

		bool mIngredient;
		bool mCookedFood;
		bool mDelivered;

		short mArraySize;
		short* mArray;

		int mTimer;

		GameObject* pSourceObject;

	public:
		TObject(GameApp* theApp, GameFrame* theFrame);
		virtual ~TObject();	

		virtual void Draw(Graphics* g);
		virtual void Update();

		virtual void AddedToManager(WidgetManager* theWidgetManager);
		virtual void RemovedFromManager(WidgetManager* theWidgetManager);

		virtual void MouseMove(int x, int y);

		virtual void InitArray(int num);
		virtual TObject* Copy();

		virtual Image* getImage();

};

}

#endif	// __TOBJECT_H__