#include "TObjectIngredient.h"
#include "TObjectFactory.h"
#include "TObject.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

TObjectIngredient::TObjectIngredient(GameApp* theApp, GameFrame* theFrame) : TObject(theApp, theFrame)
{
	mType = TObjectFactory::BASIL;
	mName = "Basil";

	pImg = NULL;

	mIngredient = true;
	mCookedFood = false;
}

TObjectIngredient::~TObjectIngredient()
{
}

void TObjectIngredient::Draw(Graphics* g)
{
	if(pImg == NULL)
	{
		g->SetColor(Color(0, 127, 127));
		g->FillRect(0, 0, mWidth, mHeight);
	}
	else
	{
		g->DrawImage(pImg,0,0);
	}
}

void TObjectIngredient::Update()
{
	Widget::Update();
}

TObject* TObjectIngredient::Copy()
{
	TObjectIngredient* newObj = new TObjectIngredient(pApp, pFrame);

	newObj->mType = mType;
	newObj->mName = mName;
	newObj->pImg = pImg;
	newObj->mColor = mColor;

	newObj->mIngredient = mIngredient;
	newObj->mCookedFood = mCookedFood;

	newObj->InitArray(mArraySize);
	for(int i=0; i<newObj->mArraySize; i++)
	{
		newObj->mArray[i] = mArray[i];
	}

	newObj->mTimer = mTimer;

	newObj->pSourceObject = pSourceObject;

	return newObj;
}


