#include "TObjectOrder.h"
#include "TObjectFactory.h"
#include "TObject.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "ObjectTable.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

TObjectOrder::TObjectOrder(GameApp* theApp, GameFrame* theFrame) : TObject(theApp, theFrame)
{
	mType = TObjectFactory::ORDER;
	mName = "Order";

	pImg = pApp->mPizzaMargheritaImg;

	mIngredient = false;
	mCookedFood = false;

	mFilled = false;
	mFilledOrderArray = NULL;
}

TObjectOrder::~TObjectOrder()
{
}

void TObjectOrder::Draw(Graphics* g)
{
	g->SetColor(Color(127, 127, 127));
	g->FillRect(0, 0, mWidth, mHeight);

	//g->DrawImage(pImg,0,0);
}

void TObjectOrder::Update()
{
	Widget::Update();
}

TObject* TObjectOrder::Copy()
{
	TObjectOrder* newObj = new TObjectOrder(pApp, pFrame);

	newObj->mType = mType;
	newObj->mName = mName;
	newObj->pImg = pImg;
	newObj->mColor = mColor;

	newObj->mIngredient = mIngredient;
	newObj->mCookedFood = mCookedFood;

	newObj->InitArray(mArraySize);
	for(int i=0; i<newObj->mArraySize; i++)
	{
		newObj->mArray[i] = mArray[i];
	}

	newObj->mTimer = mTimer;

	newObj->pSourceObject = pSourceObject;

	return newObj;
}

void TObjectOrder::InitArray(int num)
{
	if(mArraySize != 0 && mArray != NULL)
	{
		delete[] mArray;
		delete[] mFilledOrderArray;
		mArraySize = 0;
	}

	mArraySize = num;
	mArray = new short[mArraySize];
	mFilledOrderArray = new bool[mArraySize];

	for(int i=0; i<mArraySize; i++)
	{
		mFilledOrderArray[i] = false;
	}
	
}


