#include "TObjectPizza.h"
#include "TObjectFactory.h"
#include "TObject.h"
#include "GameApp.h"
#include "GameFrame.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

TObjectPizza::TObjectPizza(GameApp* theApp, GameFrame* theFrame) : TObject(theApp, theFrame)
{
	mType = TObjectFactory::MARGHERITA;
	mName = "Pizza Margherita";

	pImg = NULL;

	mIngredient = false;
	mCookedFood = false;

}

TObjectPizza::~TObjectPizza()
{
}

void TObjectPizza::Draw(Graphics* g)
{
	if(pImg == NULL)
	{
		g->SetColor(Color(0, 127, 127));
		g->FillRect(0, 0, mWidth, mHeight);
	}
	else
	{
		if(!mCookedFood)
		{
			g->mColorizeImages = true;
			g->SetColor(Color(190,190,190));
		}
		else
		{
			g->mColorizeImages = false;
		}

		g->DrawImage(pImg,0,0,mWidth,mHeight);

		g->mColorizeImages = false;
	}

}

void TObjectPizza::Update()
{
	Widget::Update();
}

TObject* TObjectPizza::Copy()
{
	TObjectPizza* newObj = new TObjectPizza(pApp, pFrame);

	newObj->mType = mType;
	newObj->mName = mName;
	newObj->pImg = pImg;
	newObj->mColor = mColor;

	newObj->mIngredient = mIngredient;
	newObj->mCookedFood = mCookedFood;

	newObj->InitArray(mArraySize);
	for(int i=0; i<newObj->mArraySize; i++)
	{
		newObj->mArray[i] = mArray[i];
	}

	newObj->mTimer = mTimer;

	newObj->pSourceObject = pSourceObject;

	return newObj;
}

Image* TObjectPizza::getImage()
{
	if(!mCookedFood)
		return pApp->mPizzaDoughImg;
	
	return pImg;
}

