#ifndef __TRAY_H__
#define __TRAY_H__

namespace Sexy
{
	class GameApp;
	class GameFrame;

	class TObject;
	class TrayWidget;

class Tray
{
	private:
		GameApp* pApp;
		GameFrame* pFrame;

		TObject** mTObjArray;
		short mTObjArraySize;
		short mNumTObjects;

		TrayWidget* mCursorWidget;
		TrayWidget* mUIWidget;

	public:
		Tray(GameApp* theApp, GameFrame* theFrame, short theSize);
		virtual ~Tray();

		Widget* getCursorWidget();
		Widget* getUIWidget();

		short getNumElementInTrayOfId(short theId);

		bool addItem(TObject* theObj);
		bool removeItem(TObject* theObj);

		bool hasSpace();
		bool isEmpty();

		TObject* getTopItem();
		TObject* getTopItemById(short theId);

		TObject* getItemByIndex(short theIndex);
		short getNumItemsInTray();
};

}

#endif	// __TRAY_H__