#include "GameApp.h"
#include "GameFrame.h"
#include "TObject.h"

#include "TrayWidget.h"
#include "Tray.h"

#include "../../../SexyAppFramework/WidgetManager.h"

using namespace Sexy;

TrayWidget::TrayWidget(GameApp* theApp, GameFrame* theFrame, Tray* theTray, short theSize)
{
	pApp = theApp;
	pFrame = theFrame;
	pTray = theTray;

	mMaxItems = theSize;
	pObjArray = new TObject*[mMaxItems];

	pBgImg = NULL;

	mNumItems = 0;

	mVertical = true;

	Resize(0, 0, 30, theSize*30); 
}

TrayWidget::~TrayWidget()
{
	delete pObjArray;
}

void TrayWidget::Draw(Graphics* g)
{
	if(pBgImg != NULL)
	{
		g->DrawImage(pBgImg, 0, 0, mWidth, mHeight);
	}
	else
	{
		//g->SetColor(Color(127,127,127,127));
		//g->FillRect(0,0,mWidth,mHeight);
	}
	
	int x = 0;
	int y = 0;
	
	for(int i=0; i<mNumItems; i++)
	{
		int w = 30;//pObjArray[mNumItems-1-i]->mWidth;
		int h = 30;//pObjArray[mNumItems-1-i]->mHeight;

		if(pObjArray[mNumItems-1-i]->mIngredient || pObjArray[mNumItems-1-i]->mCookedFood)
		{
			Color c;
			c = pObjArray[mNumItems-1-i]->mColor;
			
			if(c != Color(255,255,255))
			{
				c.mAlpha = 159;
				g->SetColor(c);
				g->FillRect(x,y,w,h);
			}

			g->DrawImage(pObjArray[mNumItems-1-i]->pImg, x, y, w, h);
		
		}
		else
		{
			Color c ;
			c = pObjArray[mNumItems-1-i]->mColor;
			//c = Color(31,31,31);

			if(c != Color(255,255,255))
			{
				c.mAlpha = 95;
				g->SetColor(c);
				g->FillRect(x,y,w,h);
			}

			g->DrawImage(pApp->mPizzaDoughImg, x, y, w, h);

		}

		if(mVertical)
		{
			y += h;
			
		}
		else
		{
			x += w;
		}
	}
}

bool TrayWidget::addItem(TObject* theItemObj)
{
	if (mNumItems < mMaxItems)
	{
		pObjArray[mNumItems] = theItemObj;

		mNumItems++;

		pFrame->MarkDirty();

		return true;
	}

	return false;
}

bool TrayWidget::removeItem(TObject* theItemObj)
{
	if(mNumItems > 0)
	{
		short indexToRemove = -1;
		
		for(int i=0; i<mNumItems; i++)
		{
			if(pObjArray[mNumItems-1-i] == theItemObj)
			{
				indexToRemove = mNumItems-1-i;
				break;
			}
		}

		if(indexToRemove != -1)
		{
			
			for(int i=indexToRemove; i<mNumItems-1; i++)
			{
				pObjArray[i] = pObjArray[i+1];
			}
			
			mNumItems--;
			pObjArray[mNumItems] = NULL;

			pFrame->MarkDirty();
			return true;
		}
	}
	
	return false;
}

void TrayWidget::setBackgroundImg(Image* theBgImg)
{
	pBgImg = theBgImg;
}

void TrayWidget::setVertical(bool toggle)
{
	if(mVertical != toggle)
	{
		Resize(mX, mY, mHeight, mWidth);

		mVertical = toggle;
	}
}

void TrayWidget::MouseMove(int x, int y)
{
	pFrame->MouseMove(x,y);
}